package POE::Component::Jabber::Server;
use Filter::Template;
use warnings;
use strict;

use POE;
use POE::Component::Jabber::Server::InputHandler;
use POE::Component::Jabber::Server::RouteProcessor;
use POE::Component::Jabber::Server::RouteTable;
use POE::Component::Jabber::Server::RosterTable;
use POE::Component::Jabber::Server::SelfRouter;
use POE::Component::Jabber::Server::SocketServer;

our $VERSION = '1.21';

sub new()
{
	my $class = shift;
	my $name = $class . '->new()';
	die "$name requires an even number of arguments" if(@_ & 1);

	my $config = {};
	while($#_ != -1)
	{
		my $key = lc(shift(@_));
		my $value = shift(@_);
		$config->{$key} = $value;
	}

	my $route = POE::Component::Jabber::Server::RouteTable->new($config);
	my $roster = POE::Component::Jabber::Server::RosterTable->new($config);

	POE::Component::Jabber::Server::InputHandler->new($config, $route);
	POE::Component::Jabber::Server::SocketServer->new($config, $route);
	POE::Component::Jabber::Server::SelfRouter->new($config, $route);
	POE::Component::Jabber::Server::RouteProcessor->new($config, $route);

}

1;

